#include <windows.h>

__inline int r_toupper(int c)
{
	if('a' <= c && c <= 'z')
		c -= 'a' - 'A';
	return c;
}

int atoi(const char *p)
{
	int r = 0;
	while(*p)
	{
		if('0' <= *p && *p <= '9')
			r = r * 10 + *p - '0';
		p++;

	}
	return r;
}

int _strnicmp(const char* d, const char* s, size_t n)
{
	int c1, c2;
	unsigned int i;
	for(i = 0; i < n; i++)
	{
		if(*s == 0 && *d == 0) break;
		c1 = r_toupper(*d); c2 = r_toupper(*s);
		if(c1 != c2) return (c1 - c2);
		d++; s++;
	}
	return 0;
}

void __cdecl WinMainCRTStartup( void )
{
	char *p, *t;
	char t_str[10];
	int time = 0;
	BOOL blink_sw = FALSE;
	HWND hwndClock, hwndTray, hwndTaskbar;
	
	hwndTaskbar = FindWindow("Shell_TrayWnd", "");
	hwndTray = FindWindowEx(hwndTaskbar, NULL, "TrayNotifyWnd", "");
	hwndClock = FindWindowEx(hwndTray, NULL, "TrayClockWClass", NULL);
	
	p = GetCommandLine();
	t = t_str;
	while(*p)
	{
		if(*p == '/')
		{
			p++;
			if(_strnicmp(p, "off", 3) == 0)
			{
				blink_sw = TRUE;
				p += 3;
			}
			else if(_strnicmp(p, "on", 2) == 0)
			{
				blink_sw = FALSE;
				p += 2;
			}
			else if(_strnicmp(p, "time:", 4) == 0)
			{
				p += 5;
				while(*p >= '0' && *p <= '9' && *p)
				{
					*t++ = *p++;
				}
			}
		}
		p++;
	}
	if (t_str[0] != 0)
		time = atoi(t_str);
	
	PostMessage(hwndClock,WM_USER+3,0,blink_sw);
	if (time > 0)
	{
		Sleep(time*1000);
		PostMessage(hwndClock,WM_USER+3,0,TRUE);
	}
	ExitProcess(0);
}
