// strings
#define IDS_CAUTION                      1
#define IDS_DLLVER                       2
#define IDS_PROPERTY                     3
#define IDS_BTNFACE                      4
#define IDS_BTNSHADOW                    5
#define IDS_BTNLIGHT                     6
#define IDS_BTNTEXT                      7
#define IDS_ADDALARM                     8
#define IDS_SOUNDFILE                    9
#define IDS_MMFILE                      10
#define IDS_ALLFILE                     11
#define IDS_PROGRAMFILE                 12

#define IDS_NONE                        13
#define IDS_RECYCLE                     14
#define IDS_OPENBY                      15
#define IDS_COPYTO                      16
#define IDS_MOVETO                      17
#define IDS_PLAY                        18
#define IDS_LABPROGRAM                  19
#define IDS_LABFOLDER                   20

#define IDS_LEFTBUTTON                  21
#define IDS_RIGHTBUTTON                 22
#define IDS_MIDDLEBUTTON                23
#define IDS_XBUTTON1                    24
#define IDS_XBUTTON2                    25
#define IDS_CLEFTBUTTON                 26
#define IDS_CRIGHTBUTTON                27
#define IDS_CMIDDLEBUTTON               28
#define IDS_CXBUTTON1                   29
#define IDS_CXBUTTON2                   30
#define IDS_SLEFTBUTTON                 31
#define IDS_SRIGHTBUTTON                32
#define IDS_SMIDDLEBUTTON               33
#define IDS_SXBUTTON1                   34
#define IDS_SXBUTTON2                   35
#define IDS_HOTKEY                      36
#define IDS_WHEEL1                      37
#define IDS_WHEEL2                      38
#define IDS_CWHEEL1                     39
#define IDS_CWHEEL2                     40
#define IDS_SWHEEL1                     41
#define IDS_SWHEEL2                     42

#define IDS_PROPDATE                    43
#define IDS_EXITWIN                     44
#define IDS_RUN                         45
#define IDS_ALLMIN                      46
#define IDS_SYNCTIME                    47
#define IDS_TIMER                       48
#define IDS_MOUSECOPY                   49
#define IDS_SCREENSAVER                 50
#define IDS_OPENFILE                    51
#define IDS_FORMAT                      52
#define IDS_FILE                        53
#define IDS_VOL1                        54
#define IDS_VOL2                        55
#define IDS_MONOFFD                     56
#define IDS_CDDRV                       57

#define IDS_BMPFILE                     58
#define IDS_BMPICONFILE                 59
#define IDS_EXEDLLFILE                  60
#define IDS_NOICON                      61
#define IDS_START                       62
#define IDS_SYNCNOW                     63
#define IDS_STARTUPLINK                 64
#define IDS_HELPURL                     65
#define IDS_HELP2CH                     66
#define IDS_LANGDLLFILE                 67
#define IDS_NOTFOUNDCLOCK               68
#define IDS_KYU                         69
#define IDS_TEXTCENTER                  70
#define IDS_TEXTLEFT                    71
#define IDS_TEXTRIGHT                   72
#define IDS_DELRECDOCS                  73
#define IDS_CALENDAR                    74
#define IDS_STARTMNU                    75
#define IDS_TASKSW                      76
#define IDS_SHOWDESK                    77
#define IDS_LOCKPC                      78
#define IDS_MCMENU                      79
#define IDS_CHANGECONF                  80
#define IDS_VOLMUTE                     81
#define IDS_VOLSET                      82
#define IDS_VOLUD                       83
#define IDS_MONOFF                      84
#define IDS_CDOPEN                      85
#define IDS_CDCLOSE                     86
#define IDS_NETINIT                     87
#define IDS_DELUS                       88
#define IDS_TICONNO                     89
#define IDS_TICONINFO                   90
#define IDS_TICONWARN                   91
#define IDS_TICONERR                    92
#define IDS_TIPFILEEXT                  93
#define IDS_GMNET                       94
#define IDS_GMCPU                       95
#define IDS_DELREGT                     96
#define IDS_DELREGOK                    97
#define IDS_DELREGNG                    98
#define IDS_DELREGNGINI                 99
#define IDS_GTBAR                       100
#define IDS_GTLINE                      101

// menu
#define IDR_MENU                        101

// menu commands
#define IDC_SHOWPROP                    100
#define IDC_SHOWHELP                    101
#define IDC_EXIT                        102
#define IDC_TIMER                       103
#define IDC_STOPTIMER                   110
#define IDC_SYNCTIME                    104
#define IDC_SHOWCALENDER                105
#define IDC_2CHHELP                     106

#define IDC_HOTKEY0                     200
#define IDC_HOTKEY1                     201
#define IDC_HOTKEY2                     202
#define IDC_HOTKEY3                     203
#define IDC_HOTKEY4                     204

// taskbar menu commands
#define IDC_RUNAPP                      401
#define IDC_CASCADE                     403
#define IDC_TILEHORZ                    404
#define IDC_TILEVERT                    405
#define IDC_DATETIME                    408
#define IDC_TASKBARPROP                 413
#define IDC_MINALL                      415
#define IDC_TASKMAN                     420
#define IDC_EXITWIN                     506

// dialogs
#define IDD_PAGECOLOR                   107
#define IDD_PAGEFORMAT                  108
#define IDD_PAGEALARM                   109
#define IDD_PAGEMOUSE                   110
#define IDD_PAGETOOLTIP                 111
#define IDD_PAGESKIN                    112
#define IDD_PAGEGRAPH                   113
#define IDD_PAGETASKBAR                 114
#define IDD_PAGEDESKTOP                 115
#define IDD_PAGESNTP                    116
#define IDD_PAGEAUTOEXEC                117
#define IDD_PAGEMISC                    118
#define IDD_PAGEABOUT                   119
#define IDD_SELECTICON                  120
#define IDD_TESTSOUND                   121
#define IDD_TIMER                       122
#define IDD_FORMAT2                     123
#define IDD_ALARMDAY                    124
#define IDD_CALENDAR                    125
#define IDD_AUTOEXECDAY                 126
#define IDD_AUTOEXECHOUR                127
#define IDD_AUTOEXECMIN                 128

// controls of dialogs

// color and font
#define IDC_CHKCOLOR                    1101
#define IDC_COLBACK                     1102
#define IDC_CHOOSECOLBACK               1103
#define IDC_CHKCOLOR2                   1104
#define IDC_COLBACK2                    1105
#define IDC_CHOOSECOLBACK2              1106
#define IDC_CHKCOLORV                   1107
#define IDC_COLFORE                     1108
#define IDC_CHOOSECOLFORE               1109
#define IDC_CHKCLKSHADOW                1110
#define IDC_CHKCLKBORDER                1111
#define IDC_COLCLKSHADOW                1112
#define IDC_CHOOSECOLCLKSHADOW          1113
#define IDC_CLKSHADOWRANGE              1114
#define IDC_SPINCLKSHADOW               1115
#define IDC_FONT                        1116
#define IDC_FONTSIZE                    1117
#define IDC_BOLD                        1118
#define IDC_ITALIC                      1119
#define IDC_VPOS                        1120
#define IDC_CLOCKHEIGHT                 1121
#define IDC_SPINCHEIGHT                 1122
#define IDC_CLOCKWIDTH                  1123
#define IDC_SPINCWIDTH                  1124
#define IDC_VERTPOS                     1125
#define IDC_SPINVPOS                    1126
#define IDC_LINEHEIGHT                  1127
#define IDC_SPINLHEIGHT                 1128
#define IDC_TEXTPOS                     1129
#define IDC_STATICSHADOW                1130

// format
#define IDC_LOCALE                      1200
#define IDC_YEAR4                       1201
#define IDC_YEAR                        1202
#define IDC_MONTH                       1203
#define IDC_MONTHS                      1204
#define IDC_DAY                         1205
#define IDC_WEEKDAY                     1206
#define IDC_HOUR                        1207
#define IDC_MINUTE                      1208
#define IDC_SECOND                      1209
#define IDC_KAIGYO                      1210
#define IDC_INTERNETTIME                1211
#define IDC_AMPM                        1212
#define IDC_12HOUR                      1213
#define IDC_CUSTOM                      1214
#define IDC_FORMAT                      1215
#define IDC_FORMATDETAIL                1216
#define IDC_SYSII                       1217
#define IDC_SYSIISPIN                   1218

#define IDC_AMSYMBOL                    1251
#define IDC_PMSYMBOL                    1252
#define IDC_ZERO                        1253

// alarm
#define IDC_ALARM                       1301
#define IDC_LABTIMEALARM                1302
#define IDC_HOURALARM                   1303
#define IDC_SPINHOUR                    1304
#define IDC_LABCOLON                    1305
#define IDC_MINUTEALARM                 1306
#define IDC_SPINMINUTE                  1307
#define IDC_ALARMDAY                    1308
#define IDC_LABSOUNDALARM               1309
#define IDC_FILEALARM                   1310
#define IDC_SANSHOALARM                 1311
#define IDC_LABTESTALARM                1312
#define IDC_TESTALARM                   1313
#define IDC_12HOURALARM                 1314
#define IDC_REPEATALARM                 1315
#define IDC_BLINKALARM                  1316
#define IDC_COMBOALARM                  1317
#define IDC_DELALARM                    1318
#define IDC_HIDDENALARMDAY              1319
#define IDC_JIHOU                       1320
#define IDC_LABSOUNDJIHOU               1321
#define IDC_FILEJIHOU                   1322
#define IDC_SANSHOJIHOU                 1323
#define IDC_LABTESTJIHOU                1324
#define IDC_TESTJIHOU                   1325
#define IDC_REPEATJIHOU                 1326
#define IDC_BLINKJIHOU                  1327
#define IDC_JIHOUPRE                    1328
#define IDC_SPINJIHOUPRE                1329
#define IDC_LABJIHOUPRE                 1330
#define IDC_JIHOUTIME                   1331
#define IDC_SPINJIHOUTIME               1332
#define IDC_LABJIHOUTIME                1340

#define IDC_ALARMDAY0                   1380
#define IDC_ALARMDAY1                   1381
#define IDC_ALARMDAY2                   1382
#define IDC_ALARMDAY3                   1383
#define IDC_ALARMDAY4                   1384
#define IDC_ALARMDAY5                   1385
#define IDC_ALARMDAY6                   1386
#define IDC_ALARMDAY7                   1387

// mouse
#define IDC_DROPFILES                   1401
#define IDC_LABDROPFILESAPP             1402
#define IDC_DROPFILESAPP                1403
#define IDC_DROPFILESAPPSANSHO          1404
#define IDC_LABMOUSEBUTTON              1405
#define IDC_MOUSEBUTTON                 1406
#define IDC_RADSINGLE                   1407
#define IDC_RADDOUBLE                   1408
#define IDC_RADTRIPLE                   1409
#define IDC_RADQUADRUPLE                1410
#define IDC_MOUSEFUNC                   1411
#define IDC_LABMOUSEFILE                1412
#define IDC_MOUSEFILE                   1413
#define IDC_MOUSEFILESANSHO             1414
#define IDC_RCLICKMENU                  1415
#define IDC_HOTKEY                      1416
#define IDC_VOL                         1417
#define IDC_VOLSPIN                     1418

// tooltip
#define IDC_TOOLTIP                     1450
#define IDC_SANSHOTIP                   1451
#define IDC_TIP2                        1452
#define IDC_TOOLTIP2                    1453
#define IDC_SANSHOTIP2                  1454
#define IDC_TIP3                        1455
#define IDC_TOOLTIP3                    1456
#define IDC_SANSHOTIP3                  1457
#define IDC_TIPTATE                     1458
#define IDC_TFONTSIZE                   1459
#define IDC_TFONT                       1460
#define IDC_TBOLD                       1461
#define IDC_TITALIC                     1462
#define IDC_BALLOONFLG                  1463
#define IDC_ALPHATIP                    1464
#define IDC_ALTIPSPIN                   1465
#define IDC_TFONCOL                     1466
#define IDC_CHOOSETFONCOL               1467
#define IDC_TBAKCOL                     1468
#define IDC_CHOOSETBAKCOL               1469
#define IDC_TTITLE                      1470
#define IDC_TICON                       1471
#define IDC_DISPT                       1472
#define IDC_DISPTSPIN                   1473
#define IDC_TINTERVAL                   1474
#define IDC_TINTERVALSPIN               1475
#define IDC_UPDATETIP1                  1476
#define IDC_UPDATETIP2                  1477
#define IDC_UPDATETIP3                  1478
#define IDC_DISABLETIPCUSTOMDRAW        1479
#define IDC_ENABLEDOUBLEBUFFERING       1480


// skin
#define IDC_STARTBTN                    1501
#define IDC_LABFILESTART                1502
#define IDC_FILESTART                   1503
#define IDC_SANSHOSTART                 1504
#define IDC_LABCAPSTART                 1505
#define IDC_CAPTIONSTART                1506
#define IDC_STARTMENU                   1507
#define IDC_LABFILEMENU                 1508
#define IDC_FILEMENU                    1509
#define IDC_SANSHOMENU                  1510
#define IDC_LABCOLMENU                  1511
#define IDC_COLMENU                     1512
#define IDC_CHOOSECOLMENU               1513
#define IDC_TILEMENU                    1514
#define IDC_STARTMORE                   1515
#define IDC_TRAYBG                      1516
#define IDC_FILETBG                     1517
#define IDC_SANSHOTBG                   1518
#define IDC_TBGUP                       1519
#define IDC_SPINTBGU                    1520
#define IDC_TBGDOWN                     1521
#define IDC_SPINTBGD                    1522
#define IDC_TBGLEFT                     1523
#define IDC_SPINTBGL                    1524
#define IDC_TBGRIGHT                    1525
#define IDC_SPINTBGR                    1526
#define IDC_LABTB1                      1527
#define IDC_LABTB2                      1528
#define IDC_LABTB3                      1529
#define IDC_LABTB4                      1530
#define IDC_LABTB5                      1531

// graph
#define IDC_TRAYGRAPH                   1550
#define IDC_GRAPHMODE                   1551
#define IDC_GRAPHTYPE                   1552
#define IDC_COLRECV                     1553
#define IDC_CHOOSECOLRECV               1554
#define IDC_COLSR                       1555
#define IDC_CHOOSECOLSR                 1556
#define IDC_COLSEND                     1557
#define IDC_CHOOSECOLSEND               1558
#define IDC_GPTATE                      1559
#define IDC_TBGGRAPHRATE                1560
#define IDC_TBGGRAPHRATE2               1561
#define IDC_CPUHIGH                     1562
#define IDC_CPUHIGHSPIN                 1563
#define IDC_RVGRAPH                     1564
#define IDC_LABG1                       1565
#define IDC_LABG2                       1566
#define IDC_LABG3                       1567
#define IDC_GINTERVAL                   1568
#define IDC_GINTERVALSPIN               1569
#define IDC_MODE11                      1570
#define IDC_MODE12                      1571
#define IDC_MODE13                      1572
#define IDC_MODE14                      1573
#define IDC_MODE15                      1574
#define IDC_MODE16                      1575
#define IDC_MODE17                      1576
#define IDC_MODE21                      1577
#define IDC_MODE22                      1578
#define IDC_MODE23                      1579
#define IDC_MODE24                      1580
#define IDC_MODE18                      1581
#define IDC_MODE19                      1582
#define IDC_MODE20                      1583
#define IDC_MODE25                      1584
#define IDC_GRAPHLEFT                   1585
#define IDC_SPGRAPHLEFT                 1586
#define IDC_GRAPHTOP                    1587
#define IDC_SPGRAPHTOP                  1588
#define IDC_GRAPHRIGHT                  1589
#define IDC_SPGRAPHRIGHT                1590
#define IDC_GRAPHBOTTOM                 1591
#define IDC_SPGRAPHBOTTOM               1592
#define IDC_MODE26                      1593

// misc
#define IDC_NOCLOCK                     1601
#define IDC_MCIWAVE                     1602
#define IDC_DELAYSTART                  1603
#define IDC_SPINDELAYSTART              1604
#define IDC_DELAYNET                    1605
#define IDC_SPINDELAYNET                1606
#define IDC_CHECKNETWORK                1607
#define IDC_CHECKNETINTERVAL            1608
#define IDC_SPINCHECKNETINTERVAL        1609
#define IDC_NETCHECKSTATIC              1610
#define IDC_DESKCAL                     1611
#define IDC_LABDESKCAL                  1612
#define IDC_COMDESKCAL                  1613
#define IDC_SANSHODESKCAL               1614
#define IDC_ONLYDATECHANGED             1615
#define IDC_RESUMESUSPEND               1616
#define IDC_TONIKAKU                    1617
#define IDC_WATCHWALL                   1618
#define IDC_STARTUP                     1619
#define IDC_DELREG                      1620
#define IDC_TASKWNDCTRL                 1621
#define IDC_CONFMAX                     1622
#define IDC_CFMAXSPIN                   1623

// about
#define IDC_ABOUTICON                   1701
#define IDC_MAILTO                      1702
#define IDC_HOMEPAGE                    1703
#define IDC_HELPURL                     1704
#define IDC_BROWSEHELP                  1705
#define IDC_HELP2CH                     1706
#define IDC_BROWSEHELP2CH               1707
#define IDC_LANGDLL                     1708
#define IDC_BROWSELANGDLL               1709

#define IDC_LABTESTSOUND                1801
#define IDC_TESTSOUND                   1802

#define IDC_FNAMEICON                   1901
#define IDC_LISTICON                    1902
#define IDC_SANSHOICON                  1903

// timer
#define IDC_TIMERNAME                   2001
#define IDC_TIMERDEL                    2002
#define IDC_TIMERMINUTE                 2003
#define IDC_TIMERSPIN                   2004
#define IDC_TIMERFILE                   2005
#define IDC_TIMERSANSHO                 2006
#define IDC_TIMERLABTEST                2007
#define IDC_TIMERTEST                   2008
#define IDC_TIMERREPEAT                 2009
#define IDC_TIMERBLINK                  2010
#define IDC_TIMERHELP                   2011

#define IDC_STARTMENULIST               2101
#define IDC_STARTMENUTEXT               2102
#define IDC_STARTMENUHIDE               2103
#define IDC_STARTMENUUP                 2105
#define IDC_STARTMENUDOWN               2106

// sntp
#define IDC_NTPSERVER                   2201
#define IDC_DELSERVER                   2202
#define IDC_SYNCTIMER                   2203
#define IDC_SYNCADAY                    2204
#define IDC_SYNCMIN                     2205
#define IDC_SYNCMINSPIN                 2206
#define IDC_LABSYNCMIN1                 2207
#define IDC_LABSYNCMIN2                 2208
#define IDC_SYNCNODIAL                  2209
#define IDC_TIMEOUT                     2210
#define IDC_TIMEOUTSPIN                 2211
#define IDC_SYNCNOW                     2212
#define IDC_SNTPLOG                     2213
#define IDC_SYNCSOUND                   2214
#define IDC_SYNCSOUNDBROWSE             2215
#define IDC_SNTPLISTHERE                2216

// taskbar
#define IDC_STARTBTNHIDE                2301
#define IDC_STARTMENUCLOCK              2302
#define IDC_STARTBTNFLAT                2303
#define IDC_TASKSWITCHFLAT              2304
#define IDC_TASKSWITCHICON              2305
#define IDC_FLATTRAY                    2306
#define IDC_FILLTRAY                    2307
#define IDC_CAPBARTRANS                 2308
#define IDC_BARTRANS                    2309
#define IDC_SPINBARTRANS                2310
#define IDC_CAPMENUTRANS                2311
#define IDC_MENUTRANS                   2312
#define IDC_SPINMENUTRANS               2313
#define IDC_TASKSWITCH_SEPARAT          2314
#define IDC_FITCLOCK                    2315
#define IDC_RBHIDE                      2316
#define IDC_TBBORDER                    2317
#define IDC_TBBORDEREX                  2318

// calendar
#define IDC_MONTHCALENDAR1              2401

// desktop
#define IDC_TRANSDESKTOPICONBK          2501
#define IDC_DESKTOPICONLIST             2502
#define IDC_DESKTOPICONCOLOR            2503
#define IDC_COLDESKTOPICON              2504
#define IDC_CHOOSECOLDESKTOPICON        2505

#define IDC_STATIC                      -1
#define stc32                           0x045f

//autoexec
#define IDC_COMBOAUTOEXEC               2601
#define IDC_AUTOEXEC                    2602
#define IDC_AUTOEXECHOUR                2603
#define IDC_AUTOEXECMIN                 2604
#define IDC_AUTOEXECDAY                 2605
#define IDC_LABSOUNDAUTOEXEC            2606
#define IDC_FILEAUTOEXEC                2607
#define IDC_SANSHOAUTOEXEC              2608
#define IDC_LABTESTAUTOEXEC             2609
#define IDC_TESTAUTOEXEC                2610
#define IDC_DELAUTOEXEC                 2611
#define IDC_ONBOOTEXEC                  2612
#define IDC_HIDDENAUTOEXECHOUR          2613
#define IDC_HIDDENAUTOEXECMIN1          2614
#define IDC_HIDDENAUTOEXECMIN2          2615
#define IDC_HIDDENAUTOEXECDAY           2616

#define IDC_AUTOEXECHOURALL             2701
#define IDC_AUTOEXECHOUR0               2702
#define IDC_AUTOEXECHOUR1               2703
#define IDC_AUTOEXECHOUR2               2704
#define IDC_AUTOEXECHOUR3               2705
#define IDC_AUTOEXECHOUR4               2706
#define IDC_AUTOEXECHOUR5               2707
#define IDC_AUTOEXECHOUR6               2708
#define IDC_AUTOEXECHOUR7               2709
#define IDC_AUTOEXECHOUR8               2710
#define IDC_AUTOEXECHOUR9               2711
#define IDC_AUTOEXECHOUR10              2712
#define IDC_AUTOEXECHOUR11              2713
#define IDC_AUTOEXECHOUR12              2714
#define IDC_AUTOEXECHOUR13              2715
#define IDC_AUTOEXECHOUR14              2716
#define IDC_AUTOEXECHOUR15              2717
#define IDC_AUTOEXECHOUR16              2718
#define IDC_AUTOEXECHOUR17              2719
#define IDC_AUTOEXECHOUR18              2720
#define IDC_AUTOEXECHOUR19              2721
#define IDC_AUTOEXECHOUR20              2722
#define IDC_AUTOEXECHOUR21              2723
#define IDC_AUTOEXECHOUR22              2724
#define IDC_AUTOEXECHOUR23              2725

#define IDC_AUTOEXECMINALL              2731
#define IDC_AUTOEXECMIN0                2732
#define IDC_AUTOEXECMIN1                2733
#define IDC_AUTOEXECMIN2                2734
#define IDC_AUTOEXECMIN3                2735
#define IDC_AUTOEXECMIN4                2736
#define IDC_AUTOEXECMIN5                2737
#define IDC_AUTOEXECMIN6                2738
#define IDC_AUTOEXECMIN7                2739
#define IDC_AUTOEXECMIN8                2740
#define IDC_AUTOEXECMIN9                2741
#define IDC_AUTOEXECMIN10               2742
#define IDC_AUTOEXECMIN11               2743
#define IDC_AUTOEXECMIN12               2744
#define IDC_AUTOEXECMIN13               2745
#define IDC_AUTOEXECMIN14               2746
#define IDC_AUTOEXECMIN15               2747
#define IDC_AUTOEXECMIN16               2748
#define IDC_AUTOEXECMIN17               2749
#define IDC_AUTOEXECMIN18               2750
#define IDC_AUTOEXECMIN19               2751
#define IDC_AUTOEXECMIN20               2752
#define IDC_AUTOEXECMIN21               2753
#define IDC_AUTOEXECMIN22               2754
#define IDC_AUTOEXECMIN23               2755
#define IDC_AUTOEXECMIN24               2756
#define IDC_AUTOEXECMIN25               2757
#define IDC_AUTOEXECMIN26               2758
#define IDC_AUTOEXECMIN27               2759
#define IDC_AUTOEXECMIN28               2760
#define IDC_AUTOEXECMIN29               2761
#define IDC_AUTOEXECMIN30               2762
#define IDC_AUTOEXECMIN31               2763
#define IDC_AUTOEXECMIN32               2764
#define IDC_AUTOEXECMIN33               2765
#define IDC_AUTOEXECMIN34               2766
#define IDC_AUTOEXECMIN35               2767
#define IDC_AUTOEXECMIN36               2768
#define IDC_AUTOEXECMIN37               2769
#define IDC_AUTOEXECMIN38               2770
#define IDC_AUTOEXECMIN39               2771
#define IDC_AUTOEXECMIN40               2772
#define IDC_AUTOEXECMIN41               2773
#define IDC_AUTOEXECMIN42               2774
#define IDC_AUTOEXECMIN43               2775
#define IDC_AUTOEXECMIN44               2776
#define IDC_AUTOEXECMIN45               2777
#define IDC_AUTOEXECMIN46               2778
#define IDC_AUTOEXECMIN47               2779
#define IDC_AUTOEXECMIN48               2780
#define IDC_AUTOEXECMIN49               2781
#define IDC_AUTOEXECMIN50               2782
#define IDC_AUTOEXECMIN51               2783
#define IDC_AUTOEXECMIN52               2784
#define IDC_AUTOEXECMIN53               2785
#define IDC_AUTOEXECMIN54               2786
#define IDC_AUTOEXECMIN55               2787
#define IDC_AUTOEXECMIN56               2788
#define IDC_AUTOEXECMIN57               2789
#define IDC_AUTOEXECMIN58               2790
#define IDC_AUTOEXECMIN59               2791

#define IDC_AUTOEXECDAY0                2701
#define IDC_AUTOEXECDAY1                2702
#define IDC_AUTOEXECDAY2                2703
#define IDC_AUTOEXECDAY3                2704
#define IDC_AUTOEXECDAY4                2705
#define IDC_AUTOEXECDAY5                2706
#define IDC_AUTOEXECDAY6                2707
#define IDC_AUTOEXECDAY7                2708
