#include <windows.h>

#ifdef CMD_LINE_OPT
__inline int r_toupper(int c)
{
	if('a' <= c && c <= 'z')
		c -= 'a' - 'A';
	return c;
}

int atoi(const char *p)
{
	int r = 0;
	while(*p)
	{
		if('0' <= *p && *p <= '9')
			r = r * 10 + *p - '0';
		p++;

	}
	return r;
}

int _strnicmp(const char* d, const char* s, size_t n)
{
	int c1, c2;
	unsigned int i;
	for(i = 0; i < n; i++)
	{
		if(*s == 0 && *d == 0) break;
		c1 = r_toupper(*d); c2 = r_toupper(*s);
		if(c1 != c2) return (c1 - c2);
		d++; s++;
	}
	return 0;
}

#endif

void __cdecl WinMainCRTStartup( void )
{
#ifdef CMD_LINE_OPT
	char *p;
#endif
	HWND hwndClock, hwndTray, hwndTaskbar;
	
	hwndTaskbar = FindWindow("Shell_TrayWnd", "");
	hwndTray = FindWindowEx(hwndTaskbar, NULL, "TrayNotifyWnd", "");
	hwndClock = FindWindowEx(hwndTray, NULL, "TrayClockWClass", NULL);
	
#ifdef CMD_LINE_OPT
	p = GetCommandLine();
	while(*p)
	{
		if(*p == '/')
		{
			p++;
			if(_strnicmp(p, "off", 3) == 0)
			{
				p += 3;
			}
			else if(_strnicmp(p, "on", 2) == 0)
			{
				p += 2;
			}
		}
		p++;
	}
#endif
	PostMessage(hwndClock,WM_USER+1,0,0);
	ExitProcess(0);
}
