# ------------------------------------------
# tclock.mak            KAZUBON 1998-2001
#-------------------------------------------

!IFNDEF SRCDIR
SRCDIR=.
!ENDIF

LIBS=kernel32.lib user32.lib

all: ..\out\tcblink.exe ..\out\tcredraw.exe ..\out\tcuserstr.exe

CC=cl
LINK=link
RC=rc
COPT=/c /W3 /O2 /DWIN32 /Fo
LOPT=/SUBSYSTEM:WINDOWS /OPT:NOWIN98 /NODEFAULTLIB /merge:.rdata=.text

..\out\tcblink.exe: tcblink.obj
    $(LINK) $(LOPT) tcblink.obj $(LIBS) /OUT:$@
..\out\tcredraw.exe: tcredraw.obj
    $(LINK) $(LOPT) tcredraw.obj $(LIBS) /OUT:$@
..\out\tcuserstr.exe: tcuserstr.obj
    $(LINK) $(LOPT) tcuserstr.obj $(LIBS) /OUT:$@


tcblink.obj: $(SRCDIR)\tcblink.c
    $(CC) $(COPT)$@ $(SRCDIR)\tcblink.c
tcredraw.obj: $(SRCDIR)\tcredraw.c
    $(CC) $(COPT)$@ $(SRCDIR)\tcredraw.c
tcuserstr.obj: $(SRCDIR)\tcuserstr.c
    $(CC) $(COPT)$@ $(SRCDIR)\tcuserstr.c
